/************************************
   EJERCICIO DEL MOTOR
   Estimadores de estado MIMO
     CLASE  TEORÍA
***********************************/
xdel(winsid());
clear all;
clc;

// VALORES
Ra=2;
La=5e-3;
J=5e-3;
B1=5e-3;
Kt=0.7;
Kw=0.8;
A0=10;
Ts=0.001;
// MATRICES
A=[-Ra/La,-Kw/La,0; Kt/J,-B1/J,0; 0,1,0];
B=[A0/La; 0; 0];
C=[0,1,0; 0,0,1];
D=[0; 0];
// MODELO DE ESTADO
P1=syslin("c",A,B,C,D)
autov=spec(P1.a)
V1=obsv_mat(A,C(1,:))
rank(V1)
// SIMULACIÓN
T = 0:0.001:0.1;
Y=csim('step',T,P1);
// GRÁFICO VARIABLES DE ESTADO A LAZO CERRADO
xdel(winsid());
subplot(2,1,1)
plot2d(T,Y(1,:),color("red"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Posición");
subplot(2,1,2)
plot2d(T,Y(2,:),color("blue"));
xgrid(color("gray"))
ylabel("Velocidad");

// Transformación a Modelo Discreto
clc;
P2=dscr(P1,Ts)
Ad=P2.a;
Bd=P2.b
Cd=P2.c
Dd=P2.d
autov=spec(Ad)
// Observabilidad
V=obsv_mat(Ad,Cd(1,:))
rank(V)
// Determinación de la salida ficticia
clc;
F=[1,1]
Cf=F*Cd
P3=syslin("d",Ad,Bd,Cf,0) // Modelo con salida ficticia
V3=obsv_mat(P3)
rank(V3)

// Estimador
clc;
z1=0;
z2=0;
z3=0;
z1=0.8;
z2=0.92;
z3=0.72;
// Vector del estimdor para salida ficticia
H1=(ppol(P3.a',P3.c',[z1,z2,z3]))'
// Matriz del estimador
H=H1*F
//  Modelo del estimador
clc;
Ae=P2.a-H*P2.c;
autov=spec(Ae)
Be=[P2.b,H];
Ce=eye(3,3);
De=zeros(3,3);
Xe0=[10;10;1];
// RESPUESTA DEL ESTIMADOR 
At=[Ad,zeros(3,3);H*Cd,Ae]
Bt=[Bd;Bd]
Ct=eye(6,6)
Dt=zeros(6,1)
Xt=[Xe0;zeros(3,1)]
Pt=syslin("d",At,Bt,Ct,Dt,Xt)
// SIMULACIÓN
T = 0:Ts:0.2;
u=ones(1,length(T));
Y=dsimul(Pt,u);
// GRÁFICO DEL ERROR
xdel(winsid());
subplot(3,1,1)
plot2d2(T,Y(1,:),color("red"));
plot2d2(T,Y(4,:),color("blue"));
xgrid(color("gray"))
title('Respuesta de las variables de estado')
ylabel("Corriente");
subplot(3,1,2)
plot2d2(T,Y(2,:),color("red"));
plot2d2(T,Y(5,:),color("blue"));
xgrid(color("gray"))
ylabel("Velocidad");
subplot(3,1,3)
plot2d2(T,Y(3,:),color("red"));
plot2d2(T,Y(6,:),color("blue"))
xgrid(color("gray"))
ylabel("Posición");
